import 'package:flutter/material.dart';
import 'CatalogMainPage.dart';
import 'package:stream2app/stream2app.dart';


final String ipv4Address = '192.168.2.4';
final serverUrl = 'ws://'+ipv4Address+':3123';


void main() {
  runApp(CatalogApp());
}


class CatalogApp extends StatelessWidget {

  CatalogApp() {
    final _customLogger = (String message, Level level, {additionalData}) {
      final PREFIX = "> CatalogApp ["
          +level.toString().toUpperCase().substring(6)
          +"]: ";
      print(PREFIX+message);
      if(additionalData!=null)
        print(additionalData.toString());
    };

    Stream2App.instance.init(serverUrl: serverUrl, logger: Logger(useDefaultLogger: false, useCustomLogger: _customLogger), projectName: 'catalog');
    Stream2App.instance.connect();

  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      title: 'Catalog',
      debugShowCheckedModeBanner: false,
      theme: ThemeData(
        primarySwatch: Colors.lightBlue,
      ),
      home: CatalogMainPage(),
    );
  }
}